/* Generated by re2c 0.13.2 */
#line 1 "_mwscan.re"
// -*- mode: c++ -*-
// Copyright (c) 2007-2008 PediaPress GmbH
// See README.txt for additional licensing information.

#include <Python.h>

#include <iostream>
#include <assert.h>
#include <vector>
using namespace std;

#define RET(x) {found(x); return x;}

typedef enum {
	t_end,
	t_text,
	t_entity,
	t_special,
	t_magicword,
	t_comment,
	t_2box_open,   // [[
	t_2box_close,  // ]]
	t_http_url,
	t_break,
	t_begin_table,
	t_end_table,
	t_html_tag,
	t_style,
	t_pre,
	t_section,
	t_section_end,
	t_item,
	t_colon,
	t_semicolon,
	t_hrule,
	t_newline,
	t_column,
	t_row,
	t_tablecaption,
	t_urllink,
} mwtok;

struct Token
{
	int type;
	int start;
	int len;
};

class Scanner
{
public:

	Scanner(Py_UNICODE *_start, Py_UNICODE *_end) {
		source = start = _start;
		end = _end;
		cursor = start;
		line_startswith_section = -1;
		tablemode=0;
	}

	int found(mwtok val) {
		if (val==t_text && tokens.size()) {
			Token &previous_token (tokens[tokens.size()-1]);
			if (previous_token.type==val) {
				previous_token.len += cursor-start;
				return tokens.size()-1;
			}
		}
		Token t;
		t.type = val;
		t.start = (start-source);
		t.len = cursor-start;			
		tokens.push_back(t);
		return tokens.size()-1;
	}

	bool bol() const {
		return (start==source) || (start[-1]=='\n');
	}

	bool eol() const {
		return *cursor=='\n' || *cursor==0;
	}

	void newline() {
		if (line_startswith_section>=0) {
			tokens[line_startswith_section].type = t_text;
		}
		line_startswith_section = -1;
	}

	inline int scan();

	Py_UNICODE *source;

	Py_UNICODE *start;
	Py_UNICODE *cursor;
	Py_UNICODE *end;
	vector<Token> tokens;

	int line_startswith_section;
	int tablemode;
};


int Scanner::scan()
{
	start=cursor;
	
	Py_UNICODE *marker=cursor;

	Py_UNICODE *save_cursor = cursor;


#define YYCTYPE         Py_UNICODE
#define YYCURSOR        cursor
#define YYMARKER	marker
#define YYLIMIT   (end)
// #define YYFILL(n) return 0;

#line 124 "_mwscan.re"


/*
  the re2c manpage says:
  "The user must arrange for a sentinel token to appear at the end of input"
  \000 is our sentinel token.
*/

#line 155 "_mwscan.re"

	if (!bol()) {
		goto not_bol;
	}

#line 140 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	yych = *YYCURSOR;
	if (yych <= ',') {
		if (yych <= '"') {
			if (yych <= 0x001F) goto yy17;
			if (yych <= ' ') goto yy2;
			if (yych <= '!') goto yy6;
			goto yy17;
		} else {
			if (yych <= '#') goto yy11;
			if (yych == '*') goto yy11;
			goto yy17;
		}
	} else {
		if (yych <= ';') {
			if (yych <= '-') goto yy15;
			if (yych <= '9') goto yy17;
			if (yych <= ':') goto yy9;
			goto yy13;
		} else {
			if (yych <= '=') {
				if (yych <= '<') goto yy17;
				goto yy7;
			} else {
				if (yych == '|') goto yy4;
				goto yy17;
			}
		}
	}
yy2:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x001F) goto yy3;
	if (yych <= '!') goto yy44;
	if (yych == '|') goto yy44;
yy3:
#line 165 "_mwscan.re"
	{RET(t_pre);}
#line 182 "_mwscan.cc"
yy4:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ',') {
		if (yych == '+') goto yy34;
	} else {
		if (yych <= '-') goto yy37;
		if (yych == '}') goto yy40;
	}
yy5:
#line 163 "_mwscan.re"
	{if (tablemode) RET(t_column) else RET(t_text);}
#line 194 "_mwscan.cc"
yy6:
	yych = *++YYCURSOR;
	goto yy5;
yy7:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy32;
	goto yy31;
yy8:
#line 166 "_mwscan.re"
	{
			line_startswith_section = found(t_section);
			return t_section;
		}
#line 208 "_mwscan.cc"
yy9:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ')') {
		if (yych == '#') goto yy26;
	} else {
		if (yych <= '*') goto yy26;
		if (yych == ':') goto yy28;
	}
yy10:
#line 171 "_mwscan.re"
	{RET(t_colon);}
#line 220 "_mwscan.cc"
yy11:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy27;
yy12:
#line 170 "_mwscan.re"
	{RET(t_item);}
#line 228 "_mwscan.cc"
yy13:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy25;
yy14:
#line 172 "_mwscan.re"
	{RET(t_semicolon);}
#line 236 "_mwscan.cc"
yy15:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '-') goto yy18;
yy16:
#line 175 "_mwscan.re"
	{goto not_bol;}
#line 244 "_mwscan.cc"
yy17:
	yych = *++YYCURSOR;
	goto yy16;
yy18:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy20;
yy19:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 0) {
		goto yy3;
	} else {
		goto yy16;
	}
yy20:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy19;
yy21:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy21;
#line 173 "_mwscan.re"
	{RET(t_hrule);}
#line 267 "_mwscan.cc"
yy24:
	++YYCURSOR;
	yych = *YYCURSOR;
yy25:
	if (yych == ';') goto yy24;
	goto yy14;
yy26:
	++YYCURSOR;
	yych = *YYCURSOR;
yy27:
	if (yych == '#') goto yy26;
	if (yych == '*') goto yy26;
	goto yy12;
yy28:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ')') {
		if (yych == '#') goto yy26;
		goto yy10;
	} else {
		if (yych <= '*') goto yy26;
		if (yych == ':') goto yy28;
		goto yy10;
	}
yy30:
	++YYCURSOR;
	yych = *YYCURSOR;
yy31:
	if (yych == 0x0009) goto yy30;
	if (yych == ' ') goto yy30;
	goto yy8;
yy32:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == 0x0009) goto yy30;
		goto yy8;
	} else {
		if (yych <= ' ') goto yy30;
		if (yych == '=') goto yy32;
		goto yy8;
	}
yy34:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '+') goto yy34;
#line 164 "_mwscan.re"
	{if (tablemode) RET(t_tablecaption) else RET(t_text);}
#line 316 "_mwscan.cc"
yy37:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == '-') goto yy37;
#line 162 "_mwscan.re"
	{if (tablemode) RET(t_row) else RET(t_text);}
#line 323 "_mwscan.cc"
yy40:
	++YYCURSOR;
#line 160 "_mwscan.re"
	{--tablemode; RET(t_end_table);}
#line 328 "_mwscan.cc"
yy42:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy34;
		goto yy5;
	} else {
		if (yych <= '-') goto yy37;
		if (yych == '}') goto yy40;
		goto yy5;
	}
yy43:
	++YYCURSOR;
	yych = *YYCURSOR;
yy44:
	if (yych <= '!') {
		if (yych <= 0x001F) goto yy19;
		if (yych <= ' ') goto yy43;
	} else {
		if (yych == '|') goto yy42;
		goto yy19;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy5;
}
#line 176 "_mwscan.re"



not_bol:
	cursor = save_cursor;
	marker = cursor;


#line 363 "_mwscan.cc"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	yych = *YYCURSOR;
	if (yych <= '=') {
		if (yych <= '&') {
			if (yych <= 0x000A) {
				if (yych <= 0x0000) goto yy67;
				if (yych <= 0x0009) goto yy69;
				goto yy57;
			} else {
				if (yych == '!') goto yy60;
				if (yych <= '%') goto yy69;
				goto yy66;
			}
		} else {
			if (yych <= '9') {
				if (yych <= '\'') goto yy64;
				if (yych <= '/') goto yy69;
				goto yy53;
			} else {
				if (yych <= ':') goto yy62;
				if (yych <= ';') goto yy69;
				if (yych <= '<') goto yy65;
				goto yy55;
			}
		}
	} else {
		if (yych <= '_') {
			if (yych <= '[') {
				if (yych <= '@') goto yy69;
				if (yych <= 'Z') goto yy53;
			} else {
				if (yych == ']') goto yy54;
				if (yych <= '^') goto yy69;
				goto yy52;
			}
		} else {
			if (yych <= 'h') {
				if (yych <= '`') goto yy69;
				if (yych <= 'g') goto yy53;
				goto yy50;
			} else {
				if (yych <= 'z') goto yy53;
				if (yych <= '{') goto yy63;
				if (yych <= '|') goto yy59;
				goto yy69;
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '[') goto yy228;
	if (yych == 'h') goto yy230;
yy49:
#line 206 "_mwscan.re"
	{RET(t_special);}
#line 421 "_mwscan.cc"
yy50:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 't') goto yy218;
	goto yy120;
yy51:
#line 187 "_mwscan.re"
	{RET(t_text);}
#line 429 "_mwscan.cc"
yy52:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy121;
	goto yy120;
yy53:
	yych = *++YYCURSOR;
	goto yy120;
yy54:
	yych = *++YYCURSOR;
	if (yych == ']') goto yy117;
	goto yy49;
yy55:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy115;
	goto yy114;
yy56:
#line 190 "_mwscan.re"
	{
			if (eol()) {
			        if (line_startswith_section>=0) {
				     line_startswith_section=-1;
				     RET(t_section_end);
                                } else {
				     RET(t_text);
                                }
			} else {
				RET(t_text);
			}
		    }
#line 459 "_mwscan.cc"
yy57:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 0x000A) goto yy110;
#line 203 "_mwscan.re"
	{newline(); RET(t_newline);}
#line 465 "_mwscan.cc"
yy59:
	yych = *++YYCURSOR;
	if (yych <= '+') {
		if (yych == '!') goto yy104;
		if (yych <= '*') goto yy49;
		goto yy108;
	} else {
		if (yych <= '{') goto yy49;
		if (yych <= '|') goto yy104;
		if (yych <= '}') goto yy106;
		goto yy49;
	}
yy60:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '!') goto yy104;
yy61:
#line 218 "_mwscan.re"
	{RET(t_text);}
#line 484 "_mwscan.cc"
yy62:
	yych = *++YYCURSOR;
	goto yy49;
yy63:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy102;
	goto yy61;
yy64:
	yych = *++YYCURSOR;
	if (yych == '\'') goto yy97;
	goto yy61;
yy65:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych == '!') goto yy81;
		if (yych <= '.') goto yy61;
		goto yy82;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy61;
			goto yy83;
		} else {
			if (yych <= '`') goto yy61;
			if (yych <= 'z') goto yy83;
			goto yy61;
		}
	}
yy66:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '9') {
		if (yych == '#') goto yy70;
		if (yych <= '/') goto yy61;
		goto yy72;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy61;
			goto yy72;
		} else {
			if (yych <= '`') goto yy61;
			if (yych <= 'z') goto yy72;
			goto yy61;
		}
	}
yy67:
	++YYCURSOR;
#line 217 "_mwscan.re"
	{newline(); return t_end;}
#line 534 "_mwscan.cc"
yy69:
	yych = *++YYCURSOR;
	goto yy61;
yy70:
	yych = *++YYCURSOR;
	if (yych <= 'W') {
		if (yych <= '/') goto yy71;
		if (yych <= '9') goto yy77;
	} else {
		if (yych <= 'X') goto yy76;
		if (yych == 'x') goto yy76;
	}
yy71:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 1) {
		if (yyaccept <= 0) {
			goto yy49;
		} else {
			goto yy61;
		}
	} else {
		if (yyaccept <= 2) {
			goto yy98;
		} else {
			goto yy51;
		}
	}
yy72:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy71;
		if (yych <= '9') goto yy72;
		if (yych <= ':') goto yy71;
	} else {
		if (yych <= 'Z') {
			if (yych <= '@') goto yy71;
			goto yy72;
		} else {
			if (yych <= '`') goto yy71;
			if (yych <= 'z') goto yy72;
			goto yy71;
		}
	}
yy74:
	++YYCURSOR;
#line 215 "_mwscan.re"
	{RET(t_entity);}
#line 583 "_mwscan.cc"
yy76:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy71;
	goto yy80;
yy77:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '/') goto yy71;
	if (yych <= '9') goto yy77;
	if (yych == ';') goto yy74;
	goto yy71;
yy79:
	++YYCURSOR;
	yych = *YYCURSOR;
yy80:
	if (yych <= ';') {
		if (yych <= '/') goto yy71;
		if (yych <= '9') goto yy79;
		if (yych <= ':') goto yy71;
		goto yy74;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy71;
			goto yy79;
		} else {
			if (yych <= '`') goto yy71;
			if (yych <= 'f') goto yy79;
			goto yy71;
		}
	}
yy81:
	yych = *++YYCURSOR;
	if (yych == '-') goto yy89;
	goto yy71;
yy82:
	yych = *++YYCURSOR;
	if (yych <= '@') goto yy71;
	if (yych <= 'Z') goto yy83;
	if (yych <= '`') goto yy71;
	if (yych >= '{') goto yy71;
yy83:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '>') {
		if (yych <= ';') {
			if (yych <= 0x0000) goto yy71;
		} else {
			if (yych <= '<') goto yy71;
			if (yych >= '>') goto yy87;
		}
	} else {
		if (yych <= 'Z') {
			if (yych >= 'A') goto yy83;
		} else {
			if (yych <= '`') goto yy85;
			if (yych <= 'z') goto yy83;
		}
	}
yy85:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '<') {
		if (yych <= 0x0000) goto yy71;
		if (yych <= ';') goto yy85;
		goto yy71;
	} else {
		if (yych != '>') goto yy85;
	}
yy87:
	++YYCURSOR;
#line 211 "_mwscan.re"
	{RET(t_html_tag);}
#line 656 "_mwscan.cc"
yy89:
	yych = *++YYCURSOR;
	if (yych != '-') goto yy71;
yy90:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy71;
		if (yych != '-') goto yy90;
	} else {
		if (yych == '=') goto yy90;
		if (yych <= '>') goto yy71;
		goto yy90;
	}
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy71;
		if (yych != '-') goto yy90;
	} else {
		if (yych == '=') goto yy90;
		if (yych <= '>') goto yy71;
		goto yy90;
	}
yy93:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= 0x0000) goto yy71;
		if (yych == '-') goto yy93;
		goto yy90;
	} else {
		if (yych <= '<') goto yy71;
		if (yych != '>') goto yy90;
	}
	++YYCURSOR;
#line 214 "_mwscan.re"
	{RET(t_comment);}
#line 695 "_mwscan.cc"
yy97:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '\'') goto yy99;
yy98:
#line 209 "_mwscan.re"
	{RET(t_style);}
#line 702 "_mwscan.cc"
yy99:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != '\'') goto yy98;
	yych = *++YYCURSOR;
	if (yych != '\'') goto yy71;
	yych = *++YYCURSOR;
	goto yy98;
yy102:
	++YYCURSOR;
#line 207 "_mwscan.re"
	{++tablemode; RET(t_begin_table);}
#line 715 "_mwscan.cc"
yy104:
	++YYCURSOR;
#line 204 "_mwscan.re"
	{if (tablemode) RET(t_column) else RET(t_special);}
#line 720 "_mwscan.cc"
yy106:
	++YYCURSOR;
#line 208 "_mwscan.re"
	{--tablemode; RET(t_end_table);}
#line 725 "_mwscan.cc"
yy108:
	++YYCURSOR;
#line 205 "_mwscan.re"
	{if (tablemode) RET(t_tablecaption) else RET(t_special);}
#line 730 "_mwscan.cc"
yy110:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych == 0x000A) goto yy110;
#line 202 "_mwscan.re"
	{newline(); RET(t_break);}
#line 737 "_mwscan.cc"
yy113:
	++YYCURSOR;
	yych = *YYCURSOR;
yy114:
	if (yych == 0x0009) goto yy113;
	if (yych == ' ') goto yy113;
	goto yy56;
yy115:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= 0x001F) {
		if (yych == 0x0009) goto yy113;
		goto yy56;
	} else {
		if (yych <= ' ') goto yy113;
		if (yych == '=') goto yy115;
		goto yy56;
	}
yy117:
	++YYCURSOR;
#line 189 "_mwscan.re"
	{RET(t_2box_close);}
#line 760 "_mwscan.cc"
yy119:
	++YYCURSOR;
	yych = *YYCURSOR;
yy120:
	if (yych <= 'Z') {
		if (yych <= '/') goto yy51;
		if (yych <= '9') goto yy119;
		if (yych <= '@') goto yy51;
		goto yy119;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy51;
			goto yy119;
		} else {
			if (yych <= '`') goto yy51;
			if (yych <= 'z') goto yy119;
			goto yy51;
		}
	}
yy121:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'E':	goto yy125;
	case 'F':	goto yy124;
	case 'N':	goto yy123;
	case 'S':	goto yy126;
	case 'T':	goto yy122;
	default:	goto yy120;
	}
yy122:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy215;
	goto yy120;
yy123:
	yych = *++YYCURSOR;
	if (yych == 'E') goto yy145;
	if (yych == 'O') goto yy146;
	goto yy120;
yy124:
	yych = *++YYCURSOR;
	if (yych == 'O') goto yy137;
	goto yy120;
yy125:
	yych = *++YYCURSOR;
	if (yych == 'N') goto yy134;
	goto yy120;
yy126:
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
yy132:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 'Z') {
		if (yych <= '/') goto yy133;
		if (yych <= '9') goto yy119;
		if (yych >= 'A') goto yy119;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy119;
		} else {
			if (yych <= '`') goto yy133;
			if (yych <= 'z') goto yy119;
		}
	}
yy133:
#line 186 "_mwscan.re"
	{RET(t_magicword);}
#line 837 "_mwscan.cc"
yy134:
	yych = *++YYCURSOR;
	if (yych != 'D') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy137:
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy145:
	yych = *++YYCURSOR;
	if (yych == 'W') goto yy202;
	goto yy120;
yy146:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':	goto yy149;
	case 'E':	goto yy148;
	case 'G':	goto yy150;
	case 'T':	goto yy147;
	default:	goto yy120;
	}
yy147:
	yych = *++YYCURSOR;
	if (yych <= 'H') {
		if (yych == 'C') goto yy185;
		goto yy120;
	} else {
		if (yych <= 'I') goto yy186;
		if (yych == 'O') goto yy187;
		goto yy120;
	}
yy148:
	yych = *++YYCURSOR;
	if (yych == 'D') goto yy174;
	goto yy120;
yy149:
	yych = *++YYCURSOR;
	if (yych == 'C') goto yy158;
	if (yych == 'O') goto yy159;
	goto yy120;
yy150:
	yych = *++YYCURSOR;
	if (yych != 'A') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'Y') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy158:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy173;
	goto yy120;
yy159:
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy173:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy174:
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy185:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy201;
	goto yy120;
yy186:
	yych = *++YYCURSOR;
	if (yych == 'T') goto yy190;
	goto yy120;
yy187:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy190:
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'V') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'R') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy201:
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy202:
	yych = *++YYCURSOR;
	if (yych != 'S') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'E') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'T') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'O') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'L') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'I') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'N') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'K') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy215:
	yych = *++YYCURSOR;
	if (yych != 'C') goto yy120;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy120;
	yych = *++YYCURSOR;
	if (yych == '_') goto yy132;
	goto yy120;
yy218:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy120;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy120;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == ':') goto yy222;
	if (yych != 's') goto yy120;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != ':') goto yy120;
yy222:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy71;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy71;
	yych = *++YYCURSOR;
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '#') {
				if (yych <= '"') goto yy71;
			} else {
				if (yych <= '$') goto yy71;
				if (yych >= '\'') goto yy71;
			}
		} else {
			if (yych <= ',') {
				if (yych >= '*') goto yy71;
			} else {
				if (yych <= ':') goto yy225;
				if (yych <= '<') goto yy71;
			}
		}
	} else {
		if (yych <= '^') {
			if (yych <= '?') {
				if (yych <= '>') goto yy71;
			} else {
				if (yych <= '@') goto yy71;
				if (yych >= '[') goto yy71;
			}
		} else {
			if (yych <= 'z') {
				if (yych == '`') goto yy71;
			} else {
				if (yych != '~') goto yy71;
			}
		}
	}
yy225:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '#') {
				if (yych >= '#') goto yy225;
			} else {
				if (yych <= '$') goto yy227;
				if (yych <= '&') goto yy225;
			}
		} else {
			if (yych <= ',') {
				if (yych <= ')') goto yy225;
			} else {
				if (yych <= ':') goto yy225;
				if (yych >= '=') goto yy225;
			}
		}
	} else {
		if (yych <= '^') {
			if (yych <= '?') {
				if (yych >= '?') goto yy225;
			} else {
				if (yych <= '@') goto yy227;
				if (yych <= 'Z') goto yy225;
			}
		} else {
			if (yych <= 'z') {
				if (yych != '`') goto yy225;
			} else {
				if (yych == '~') goto yy225;
			}
		}
	}
yy227:
#line 185 "_mwscan.re"
	{RET(t_http_url);}
#line 1144 "_mwscan.cc"
yy228:
	++YYCURSOR;
#line 188 "_mwscan.re"
	{RET(t_2box_open);}
#line 1149 "_mwscan.cc"
yy230:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy71;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy71;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy71;
	yych = *++YYCURSOR;
	if (yych == ':') goto yy235;
	if (yych != 's') goto yy71;
	yych = *++YYCURSOR;
	if (yych != ':') goto yy71;
yy235:
	yych = *++YYCURSOR;
	if (yych != '/') goto yy71;
	yych = *++YYCURSOR;
	if (yych != '/') goto yy71;
	yych = *++YYCURSOR;
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '#') {
				if (yych <= '"') goto yy71;
			} else {
				if (yych <= '$') goto yy71;
				if (yych >= '\'') goto yy71;
			}
		} else {
			if (yych <= ',') {
				if (yych >= '*') goto yy71;
			} else {
				if (yych <= ':') goto yy238;
				if (yych <= '<') goto yy71;
			}
		}
	} else {
		if (yych <= '^') {
			if (yych <= '?') {
				if (yych <= '>') goto yy71;
			} else {
				if (yych <= '@') goto yy71;
				if (yych >= '[') goto yy71;
			}
		} else {
			if (yych <= 'z') {
				if (yych == '`') goto yy71;
			} else {
				if (yych != '~') goto yy71;
			}
		}
	}
yy238:
	++YYCURSOR;
	yych = *YYCURSOR;
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '#') {
				if (yych >= '#') goto yy238;
			} else {
				if (yych <= '$') goto yy240;
				if (yych <= '&') goto yy238;
			}
		} else {
			if (yych <= ',') {
				if (yych <= ')') goto yy238;
			} else {
				if (yych <= ':') goto yy238;
				if (yych >= '=') goto yy238;
			}
		}
	} else {
		if (yych <= '^') {
			if (yych <= '?') {
				if (yych >= '?') goto yy238;
			} else {
				if (yych <= '@') goto yy240;
				if (yych <= 'Z') goto yy238;
			}
		} else {
			if (yych <= 'z') {
				if (yych != '`') goto yy238;
			} else {
				if (yych == '~') goto yy238;
			}
		}
	}
yy240:
#line 184 "_mwscan.re"
	{RET(t_urllink);}
#line 1238 "_mwscan.cc"
}
#line 219 "_mwscan.re"

}


PyObject *py_scan(PyObject *self, PyObject *args) 
{
	PyObject *arg1;
	if (!PyArg_ParseTuple(args, "O:mwscan.scan", &arg1)) {
		return 0;
	}
	PyUnicodeObject *unistr = (PyUnicodeObject*)PyUnicode_FromObject(arg1);
	if (unistr == NULL) {
		PyErr_SetString(PyExc_TypeError,
				"parameter cannot be converted to unicode in mwscan.scan");
		return 0;
	}

	Py_UNICODE *start = unistr->str;
	Py_UNICODE *end = start+unistr->length;
	

	Scanner scanner (start, end);
	Py_BEGIN_ALLOW_THREADS
	while (scanner.scan()) {
	}
	Py_END_ALLOW_THREADS
	Py_XDECREF(unistr);
	
	// return PyList_New(0); // uncomment to see timings for scanning

	int size = scanner.tokens.size();
	PyObject *result = PyList_New(size);
	if (!result) {
		return 0;
	}
	
	for (int i=0; i<size; i++) {
		Token t = scanner.tokens[i];
		PyList_SET_ITEM(result, i, Py_BuildValue("iii", t.type, t.start, t.len));
	}
	
	return result;
}



static PyMethodDef module_functions[] = {
	{"scan", (PyCFunction)py_scan, METH_VARARGS, "scan(text)"},
	{0, 0},
};



extern "C" void init_mwscan(void);

DL_EXPORT(void) init_mwscan(void)
{
	/*PyObject *m =*/ Py_InitModule("_mwscan", module_functions);
}
